#include <math.h>
#define PI 3.141592653589793238462643
void gofskewn(double *x1, double *x2, int *n, double *d1, double *d2, double *om, double *a, double *t)
{
    int j, k;
    double k1, k2, x1jk, x2jk, i0x1, i0x2, i1x1, i1x2, i2x1, i2x2, t1 ,t2, t3, t4, t5, t6, t7, t8, k1dx, k2dx;
    k1= *d1 - *om * *d2;
    k2= *d2 - *om * *d1;
    t1 = 0.0;
    t2 = 0.0;
    t3 = 0.0;
    t4 = 0.0;
    t5 = 0.0;
    t6 = 0.0;
    t7 = 0.0;
    t8 = 0.0;
    for(j = 0; j < *n; j++)
    {
	k1dx = k1 * ( *d2 * x1[j] - *d1 * x2[j] ); 
	k2dx = k2 * ( *d1 * x2[j] - *d2 * x1[j] ); 
	for( k = 0; k < j; k++)
	{
	    x1jk = x1[j]+x1[k]; 
	    x2jk = x2[j]+x2[k];
	    i0x1 = exp((x1jk * x1jk)/(4.0 * *a) + 0.5 * log(PI / *a));
	    i0x2 = exp((x2jk * x2jk)/(4.0 * *a) + 0.5 * log(PI / *a));
	    i1x1 = i0x1 * x1jk / (2.0 *  *a);
	    i1x2 = i0x2 * x2jk / (2.0 *  *a);
	    i2x1 = i0x1 * (1.0 + ((x1jk * x1jk)/(2.0 *  *a))) / (2.0 *  *a);
	    i2x2 = i0x2 * (1.0 + ((x2jk * x2jk)/(2.0 *  *a))) / (2.0 *  *a);
	    t1 += x1[j] * x1[k] * i0x1 * i0x2;
	    t2 += x2[j] * x2[k] * i0x1 * i0x2;
	    t3 += (x1[j] * x2[k] + x1[k] * x2[j]) * i0x1 * i0x2;
	    t4 += i2x1 * i0x2;
	    t5 += i2x2 * i0x1;
	    t6 += i1x1 * i1x2;
	    t7 += (k1dx + k1 * ( *d2 * x1[k] - *d1 * x2[k] )) * i1x2 * i0x1;
	    t8 += (k2dx + k2 * ( *d1 * x2[k] - *d2 * x1[k] )) * i1x1 * i0x2;
	}
	x1jk = x1[j]+x1[j]; 
	x2jk = x2[j]+x2[j];
	i0x1 = exp((x1jk * x1jk)/(4.0 * *a) + 0.5 * log(PI / *a));
	i0x2 = exp((x2jk * x2jk)/(4.0 * *a) + 0.5 * log(PI / *a));
	i1x1 = i0x1 * x1jk / (2.0 *  *a);
	i1x2 = i0x2 * x2jk / (2.0 *  *a);
	i2x1 = i0x1 * (1.0 + ((x1jk * x1jk)/(2.0 *  *a))) / (2.0 *  *a);
	i2x2 = i0x2 * (1.0 + ((x2jk * x2jk)/(2.0 *  *a))) / (2.0 *  *a);
	t1 += 0.5 * x1[j] * x1[j] * i0x1 * i0x2;
	t2 += 0.5 * x2[j] * x2[j] * i0x1 * i0x2;
	t3 += x1[j] * x2[j] * i0x1 * i0x2;
	t4 += 0.5 * i2x1 * i0x2;
	t5 += 0.5 * i2x2 * i0x1;
	t6 += 0.5 * i1x1 * i1x2;
	t7 += k1dx * i1x2 * i0x1;
	t8 += k2dx * i1x1 * i0x2;
    }
    *t = 2.0*((*d2 * *d2)*t1+(*d1 * *d1)*t2-(*d1 * *d2)*(t3)+k2*k2*t4+k1*k1*t5-2.0*k1*k2*t6+t7+t8)/ *n; 
}
